#ifndef __MEMORY____H__
#define __MEMORY____H__

#include <SDL.h>

// called after the memory update occurs
typedef void func_on_memory_write_callback(Uint16 address);

void memory_start(func_on_memory_write_callback onMemoryWriteCallback);
void memory_destroy();

void memory_load(Uint8* source, Uint16 offset, Uint16 size);

Uint8 memory_read8(Uint16 address);
Uint16 memory_read16(Uint16 address);

void memory_write8(Uint16 address, Uint8 value);
void memory_write16(Uint16 address, Uint16 value);

#endif  // !__MEMORY____H__